/*
  Library support for FlexRadio 6000 Rigs
  Copyright (C)2015 Vincenzo Stefanazzi - IW7DMH. All right reserved

  This library is free software; you can redistribute it and/or
  modify it under the terms of the CC BY-NC-SA 3.0 license.
  https://creativecommons.org/licenses/by-nc-sa/3.0/
  
  The license applies to all part of the library including the 
  examples and tools supplied with the library.
*/
#include "Eq.h"
Eq::Eq() {
	updated=false;
}

void Eq::updateStatus(String msg) {

	int t=msg.indexOf(' ',0);
	String type=msg.substring(0,t);
	//Serial.println(type);
	msg=msg.substring(t+1);
	//Serial.println(msg);
	updated=true;
	
	int oldi=0;
	int i=msg.indexOf(' ',oldi);
	
	if (type.equals("rxsc")) {
		while (i>0) {
			setRxValue(msg.substring(oldi,i));
			oldi=i+1;
			i=msg.indexOf(' ',oldi+1);
		}
		//get the last element
		i=msg.indexOf('\n',oldi);
		setRxValue(msg.substring(oldi,i));
	}

	if (type.equals("txsc")) {
		while (i>0) {
			setTxValue(msg.substring(oldi,i));
			oldi=i+1;
			i=msg.indexOf(' ',oldi+1);
		}
		//get the last element
		i=msg.indexOf('\n',oldi);
		setTxValue(msg.substring(oldi,i));
	}
	/*
    Serial.println(RX_mode);
	Serial.println(RX_63Hz);
	Serial.println(RX_125Hz);
	Serial.println(RX_250Hz);
	Serial.println(RX_500Hz);
	Serial.println(RX_1000Hz);
	Serial.println(RX_2000Hz);
	Serial.println(RX_4000Hz);
	Serial.println(RX_8000Hz);
	Serial.println(TX_mode);
	Serial.println(TX_63Hz);
	Serial.println(TX_125Hz);
	Serial.println(TX_250Hz);
	Serial.println(TX_500Hz);
	Serial.println(TX_1000Hz);
	Serial.println(TX_2000Hz);
	Serial.println(TX_4000Hz);
	Serial.println(TX_8000Hz);
	*/

}

void Eq::setRxValue(String msg){
	int i=msg.indexOf('=');
	if (i>0) {
	    String var=msg.substring(0,i);
		//Serial.print(var); Serial.print("=");Serial.println(msg.substring(i+1));
		if (var.equals("mode")) { 
			//Serial.print("fRig.eq.RX_mode(before)="); Serial.println(RX_mode);
			RX_mode=msg.substring(i+1).toInt(); 
			//Serial.print("fRig.eq.RX_mode(after)="); Serial.println(RX_mode);
			return;  
		}
		if (var.equals("63Hz")) { RX_63Hz=msg.substring(i+1).toInt(); return;  }
		if (var.equals("125Hz")) { RX_125Hz=msg.substring(i+1).toInt(); return;  }
		if (var.equals("250Hz")) { RX_250Hz=msg.substring(i+1).toInt(); return;  }
		if (var.equals("500Hz")) { RX_500Hz=msg.substring(i+1).toInt(); return;  }
		if (var.equals("1000Hz")) { RX_1000Hz=msg.substring(i+1).toInt(); return;  }
		if (var.equals("2000Hz")) { RX_2000Hz=msg.substring(i+1).toInt(); return;  }
		if (var.equals("4000Hz")) { RX_4000Hz=msg.substring(i+1).toInt(); return;  }
		if (var.equals("8000Hz")) { RX_8000Hz=msg.substring(i+1).toInt(); return;  }
	}	
}

void Eq::setTxValue(String msg){
	int i=msg.indexOf('=');
	if (i>0) {
	    String var=msg.substring(0,i);
		//Serial.print(var); Serial.print("=");Serial.println(msg.substring(i+1));
		if (var.equals("mode")) { 
		    //Serial.print("fRig.eq.TX_mode(before)="); Serial.println(TX_mode);
			TX_mode=msg.substring(i+1).toInt();  
			//Serial.print("fRig.eq.TX_mode(after)="); Serial.println(TX_mode);
			return; 
		}
		if (var.equals("63Hz")) { TX_63Hz=msg.substring(i+1).toInt(); return;  }
		if (var.equals("125Hz")) { TX_125Hz=msg.substring(i+1).toInt(); return;  }
		if (var.equals("250Hz")) { TX_250Hz=msg.substring(i+1).toInt(); return;  }
		if (var.equals("500Hz")) { TX_500Hz=msg.substring(i+1).toInt(); return;  }
		if (var.equals("1000Hz")) { TX_1000Hz=msg.substring(i+1).toInt(); return;  }
		if (var.equals("2000Hz")) { TX_2000Hz=msg.substring(i+1).toInt(); return;  }
		if (var.equals("4000Hz")) { TX_4000Hz=msg.substring(i+1).toInt(); return;  }
		if (var.equals("8000Hz")) { TX_8000Hz=msg.substring(i+1).toInt(); return;  }
	}	
}


void Eq::updateObject(int objectId,int value){
	switch(objectId) {
	    
		case  EQ_RX_MODE:
			  RX_mode=value;
			  break;
		case  EQ_RX_63HZ: 
			  RX_63Hz=value;
			  break;
		case  EQ_RX_125HZ:
              RX_125Hz=value;
			  break;
		case  EQ_RX_250HZ:
			  RX_250Hz=value;
			  break;
		case  EQ_RX_500HZ:
			  RX_500Hz=value;
			  break;
		case  EQ_RX_1000HZ:
			  RX_1000Hz=value;
			  break;
		case  EQ_RX_2000HZ:
			  RX_2000Hz=value;
			  break;
		case  EQ_RX_4000HZ:
			  RX_4000Hz=value;
			  break;
		case  EQ_RX_8000HZ:
			  RX_8000Hz=value;
			  break;
		case  EQ_TX_MODE:
		      //Serial.print("fRig.eq.TX_mode(before) UPDATE OBJECT="); Serial.println(TX_mode);
			  //Serial.print("value="); Serial.println(value);
			  TX_mode=value;
			  //Serial.print("fRig.eq.TX_mode(after) UPDATE OBJECT="); Serial.println(TX_mode);
			  break;
		case  EQ_TX_63HZ:
			  TX_63Hz=value;	
			  break;
		case  EQ_TX_125HZ:
              TX_125Hz=value;
			  break;
		case  EQ_TX_250HZ:
			  TX_250Hz=value;
			  break;
		case  EQ_TX_500HZ:
			  TX_500Hz=value;
			  break;
		case  EQ_TX_1000HZ:
			  TX_1000Hz=value;
			  break;
		case  EQ_TX_2000HZ:
			  TX_2000Hz=value;
			  break;
		case  EQ_TX_4000HZ:
			  TX_4000Hz=value;
			  break;
		case  EQ_TX_8000HZ:
			  TX_8000Hz=value;
			  break;
		default:
			  Serial.print("Eq::updateObject - Unhandled id:"); Serial.println(objectId);
	}
}			  