/*
  Library support for FlexRadio 6000 Rigs
  Copyright (C)2015 Vincenzo Stefanazzi - IW7DMH. All right reserved

  This library is free software; you can redistribute it and/or
  modify it under the terms of the CC BY-NC-SA 3.0 license.
  https://creativecommons.org/licenses/by-nc-sa/3.0/
  
  The license applies to all part of the library including the 
  examples and tools supplied with the library.
*/
#ifndef Transmit_h
#define Transmit_h
#include "Arduino.h"

#define TRANSMIT_RF_POWER 3000
#define TRANSMIT_ATU_POWER 3001
#define TRANSMIT_BREAK_IN_DELAY 3002
#define TRANSMIT_MONITOR_GAIN_CW 3003
#define TRANSMIT_MONITOR_PAN_CW 3004
#define TRANSMIT_SPEED 3005
#define TRANSMIT_PITCH 3006
#define TRANSMIT_MIC_LEVEL 3007
#define TRANSMIT_MONITOR_GAIN_SB 3008
#define TRANSMIT_COMPANDER_LEVEL 3009
#define TRANSMIT_VOX_LEVEL 3010
#define TRANSMIT_VOX_DELAY 3011
#define TRANSMIT_AM_CARRIER 3012
#define TRANSMIT_LO 3013
#define TRANSMIT_HI 3014 



class Transmit
{
  public:
    //properties
	int freq;// =14.0366 
	int lo;// =100 
	int hi;// =2900 
	int rfpower;// =3 
	int tunepower;// =10 
	int am_carrier_level;// =100 
	int vox_enable;// =0 
	int vox_level;// =50 
	int vox_delay;// =250 
	int mic_level;// =40 
	String mic_selection;// =MIC 
	int mic_boost;// =1 
	int mic_bias;// =0 
	int mic_acc;// =0 
	int compander;// =1 
	int compander_level;// =70 
	int dax;// =0 
	int pitch;// =540 
	int speed;// =23 
	int iambic;// =1 
	int iambic_mode;// =1 
	int cwl_enabled;// =0 
	int swap_paddles;// =0 
	int break_in;// =1 
	int break_in_delay;// =9 
	int sidetone;// =1 
	int monitor;// =0 
	int mon_gain_cw;// =76 
	int mon_gain_sb;// =80 
	int mon_pan_cw;// =50 
	int mon_pan_sb;// =50 
	int tune;// =0 
	int met_in_rx;// =0 
	int hwalc_enabled;// =0 
	int inhibit;// =0 
	int speech_processor_enable;// =1
	int speech_processor_level;// =0 
	int show_tx_in_waterfall;// =0

    //methods
    Transmit();
	void updateStatus(String msg);
	void updateObject(int objectId,int value);  //Update specific transmit object	
	boolean updated;
  private:
    //properties
	
    //methods	
	void setValue(String msg);
};
	
#endif